<?php

/**
 * Created by AdamM on 28.10.2014
 */
require_once(dirname(_PS_MODULE_DIR_).'/modules/przelewy24/class_przelewy24.php');

class Przelewy24PaymentStatusModuleFrontController extends ModuleFrontController {
	public $ssl = true;
    private function addCard($uid, $oid) {
        if ($uid>0 && Configuration::get('P24_ONECLICK_ENABLED') && strlen(Configuration::get('P24_API_KEY'))==32) {

			$ccards_forget = Db::getInstance()->getRow('SELECT cc_forget FROM '._DB_PREFIX_.'przelewy24_customersettings WHERE customer_id='.$uid);
			if ((int)$ccards_forget['cc_forget'] == 1) return; // nie zapamiętuj karty - Customer sobie nie życzy
			
            try {
                $P24C = new Przelewy24Class(Configuration::get('P24_MERCHANT_ID'), Configuration::get('P24_SHOP_ID'), Configuration::get('P24_SALT'), Configuration::get('P24_TEST_MODE'));
				$przelewy24 = new Przelewy24();
                $s=new SoapClient($P24C->getHost().$przelewy24->getWsdlCCService(), array('trace'=>true, 'exceptions'=>true));

                $res=$s->GetTransactionReference(Configuration::get('P24_SHOP_ID'), Configuration::get('P24_API_KEY'), $oid);
                if ($res->error->errorCode === 0) {
                    $ref=$res->result->refId;
                    $exp=substr($res->result->cardExp,2,2).substr($res->result->cardExp,0,2);
                    if (!empty($ref)) {
						$hasRecurency = $s->CheckCard(Configuration::get('P24_SHOP_ID'), Configuration::get('P24_API_KEY'),$ref);
						if ($hasRecurency->error->errorCode === 0 && $hasRecurency->result == true) {
							if (date('ym')<=$exp) {
								Db::getInstance()->Execute("REPLACE INTO "._DB_PREFIX_."p24_recuring (`website_id`, `customer_id`, `reference_id`, `expires`, `mask`, `card_type`) ".
									   "VALUES (1, ".$uid.", '".$ref."', '".$exp."', '".$res->result->mask."', '".$res->result->cardType."')");
								Hook::exec('actionPaymentCCAdd');
							} else {
								error_log(__METHOD__.' termin ważności '.var_export($exp, true));
							}
						} else {
							error_log(__METHOD__.' nie ma rekurencji '.var_export($hasRecurency, true));
						}
                    }
                }
            } catch(Exception $e) {
				error_log(__METHOD__.' '.$e->getMessage());
			}
        }
    }
    public function initContent() {
        $P24C = new Przelewy24Class(Configuration::get('P24_MERCHANT_ID'), Configuration::get('P24_SHOP_ID'), Configuration::get('P24_SALT'), Configuration::get('P24_TEST_MODE'));
        $przelewy24 = new Przelewy24();
        $debug=false;
        if (Configuration::get('P24_DEBUG') and isset($_GET['test']) and $_GET['test']==md5('p24'.Configuration::get('P24_SALT').'debug')) $debug=true;

        if ($debug) {
            echo 'v.'.$przelewy24->version.'<br /><pre>';
            var_dump($P24C->testConnection());
            echo "\nPOST:\n";
            var_dump($_POST);
            echo "\nMerchant ID:\n";
            var_dump(Configuration::get('P24_MERCHANT_ID'));
            echo "\nShop ID:\n";
            var_dump(Configuration::get('P24_SHOP_ID'));
            echo "\n";
        }
    
        if ($_POST['p24_session_id']!=null) {
            list($cartID,$sa_sid) = explode('|', $_POST["p24_session_id"], 2);
			$cartID = (int)$cartID;
			$sa_sid = pSQL($sa_sid);

            $cart = new Cart($cartID);

            $address = new Address((int)$cart->id_address_delivery);
            
            Context::getContext()->currency=Currency::getCurrencyInstance((int)$cart->id_currency);
			
            $przelewy24 = new Przelewy24();
            $o_order = Db::getInstance()->getRow('SELECT `i_id_order`,`i_amount` FROM `'._DB_PREFIX_.'przelewy24_amount` WHERE `s_sid`="'.$sa_sid.'"');
			if ($debug) {
				echo "\no_order:\n";
				var_dump($sa_sid);
				var_dump($o_order);
			}            
            $amount = (int)$o_order['i_amount'];
            $currency = $przelewy24->getCurrencyCode(intval($cart->id_currency));

            $orderBeginingState = Configuration::get('P24_ORDER_STATE_1');

			if ($_POST['action'] == 'trnVerify' && !empty($_POST['p24_order_id'])) {

				$_POST['p24_merchant_id'] = Configuration::get('P24_MERCHANT_ID'); 
				$_POST['p24_pos_id'] = Configuration::get('P24_SHOP_ID');
				$_POST['p24_amount'] = $amount;
				$_POST['p24_currency'] = $currency;
				$_POST['p24_method'] = 142;

				$_POST['p24_sign'] = md5($_POST['p24_session_id'].'|'.$_POST['p24_order_id'].'|'.$amount.'|'.$currency.'|'.Configuration::get('P24_SALT'));
			}
            if ($cart->OrderExists() == null) {
				
				$extracharge_amount = $przelewy24->getExtrachargeAmount($cart->id);
				if ($extracharge_amount > 0) {
					$extracharge_product = (int)Configuration::get('P24_EXTRACHARGE_PRODUCT');
					$product = new Product($extracharge_product, true);
					$new_price = $extracharge_amount / 100;
					if ($product->tax_rate > 0) {
						 $new_price = $extracharge_amount / (100 + $product->tax_rate);
					}
					$new_price = round($new_price, 8);
					$product->price = $new_price;
					$product->save();
					Db::getInstance()->Execute("UPDATE "._DB_PREFIX_."product_shop set price = {$new_price} WHERE id_product = {$extracharge_product}");
					Db::getInstance()->Execute("UPDATE "._DB_PREFIX_."product      set price = {$new_price} WHERE id_product = {$extracharge_product}");
					$product->flushPriceCache();
					StockAvailable::setQuantity($product->id, null, 10000);
					$cart->updateQty(1, $product->id, null, false);
					$cart->update();
					$cart->getPackageList(true);
				}
				
				$customer = new Customer((int)($cart->id_customer));
                $przelewy24->validateOrder($cart->id, (int)$orderBeginingState, floatval($amount/100), 'Przelewy24', NULL, array(), NULL, false, $customer->secure_key);

            } elseif($debug) {
                echo "\n".' HAD BASKET '."\n";
            }
            
            $validation=array('p24_amount'=>$amount, 'p24_currency'=>$currency);
            $WYNIK=$P24C->trnVerifyEx($validation);
            
            $order_id = Order::getOrderByCartId($cart->id);

			if($debug) {
				var_dump('Wynik:');
				var_dump($WYNIK);
				print_r(Db::getInstance()->executeS("SELECT count(*) from "._DB_PREFIX_."przelewy24_amount"));

                var_dump($validation);
			}
			
            if ($WYNIK===null) {
                exit("\n".'MALFORMED POST DATA');
            } elseif ($WYNIK===true) {
				if ($order_id) {
                $this->setOrderState($order_id, Configuration::get('P24_ORDER_STATE_2'));

                $order = new Order($order_id);
                $_POST['p24_method'] = intval($_POST['p24_method']);

				/* zapis wybranej metody płatności - do statystyk kolejności */
				Db::getInstance()->Execute('UPDATE `'._DB_PREFIX_.'przelewy24_amount` SET p24_method = '.$_POST['p24_method'].' WHERE `s_sid`="'.$sa_sid.'"');

                if (in_array($_POST['p24_method'],array(140,142,145))) {
                    $this->addCard($order->id_customer, intval($_POST['p24_order_id']));
					Db::getInstance()->Execute("DELETE FROM "._DB_PREFIX_."przelewy24_lastmethod WHERE customer_id = {$order->id_customer} LIMIT 1");
                } else {
					Db::getInstance()->Execute("REPLACE INTO "._DB_PREFIX_."przelewy24_lastmethod (customer_id, p24_method) VALUES ( {$order->id_customer}, {$_POST[p24_method]} )");
				}
				}
				Hook::exec('actionPaymentConfirmation', array('id_order' => $order->id));
                exit("\n".'OK');
            } else {
                if ($order_id) $this->setOrderState($order_id, Configuration::get('PS_OS_ERROR'));
                exit("\n".'ERROR');
            }
        } else {
            exit('INVALID_SESSION_ID');
        }
    }
    
    private function setOrderState($order_id, $state) {
        $order = new Order($order_id);
        $history = new OrderHistory();
        $history->id_order = intval($order_id);
        $history->changeIdOrderState($state, intval($order_id));
        $history->addWithemail(true);
        
        if (method_exists($order, 'getOrderPaymentCollection')) {
            $payments = $order->getOrderPaymentCollection();
            if (count($payments) > 0) {
                    $payments[0]->transaction_id = $_POST["p24_order_id"];
                    $payments[0]->update();
            }
        }
    }
}
