<?php
/**
 * Created by michalz on 13.03.14
 * Modified by AdamM on 28.10.2014
 * Modified by Kzielin on 2015-06
 */
ini_set("display_errors", 0);
ini_set("error_reporting", E_ALL & ~E_NOTICE & ~E_STRICT & ~E_DEPRECATED);

if (!defined('_PS_VERSION_'))
    die("Nieznana wersja Prestashop/Unknown Prestashop version.");
require_once(dirname(__FILE__).'/class_przelewy24.php');
class Przelewy24 extends PaymentModule {
    /**
     *
     */
    public $currencies = true;
    public $currencies_mode = 'checkbox';

    public function __construct() {
        $this->name = 'przelewy24';
        $this->tab = 'payments_gateways';
        $this->version = '3.2.9p';
        $this->currencies = true;
        $this->author = 'Dialcom24';
        $this->module_key = "5904b0e92c361acd8b5e76bb45b60b2b";
        $this->need_instance = 0;
        $this->ps_versions_compliancy = array('min' => '1.5', 'max' => '1.6');
        $this->currencies = true;
        $this->currencies_mode = 'checkbox';
        $this->bootstrap = true;
        $this->p24_css = 'https://secure.przelewy24.pl/skrypty/ecommerce_plugin.css.php';
        $this->discount_code_prefix = 'P24_';
        parent::__construct();
        $this->displayName = $this->l('Przelewy24');
        if (_PS_VERSION_<1.5) {
            $this->description = 'Wtyczka Przelewy24 w wersji 3 przeznaczona jest wyłącznie dla PrestaShop 1.5 i nowszych. Dla starszych wersji Prestashop użyj wtyczki w wersji 2.x.x (dostępna na naszej stronie internetowej).';
            parent::uninstall();
        } else {
            $this->description = $this->l('Przelewy24.pl Payment Service');
        }
        $this->confirmUninstall = $this->l('Are you sure you want to uninstall?');

        if (Configuration::get('P24_ORDER_STATE_1')===null) {
            Configuration::updateValue('P24_ORDER_STATE_1', 1);
        }
        if (Configuration::get('P24_ORDER_STATE_2')===null) {
            Configuration::updateValue('P24_ORDER_STATE_2', 2);
        }

        if (Configuration::get('P24_INSTALLMENT_SHOW')===null) {
            Configuration::updateValue('P24_INSTALLMENT_SHOW', 0);
        }

        if (Configuration::get("P24_ORDER_TITLE_ID")===null) {
            Configuration::updateValue("P24_ORDER_TITLE_ID", 0);
        }

        if (Configuration::get("P24_SHOW_SUMMARY")===null) {
            Configuration::updateValue("P24_SHOW_SUMMARY", 0);
        }
        
        if (Configuration::get("P24_DEBUG")===null) {
            Configuration::updateValue("P24_DEBUG", 0);
        }
        
        if (Configuration::get("P24_VERIFYORDER")===null) {
            Configuration::updateValue("P24_VERIFYORDER", 0);
        }

        if (Configuration::get('P24_CONFIGURED') != 1) {
            $this->warning = $this->l('Module is not configured.');
		}

        
    }

    private function validateCredentials($merchant, $pos, $salt, $test) {
		Configuration::updateValue('P24_CONFIGURED', 0);
		try {
			$P24C=new Przelewy24Class($merchant, $pos, $salt, $test);
			$ret=$P24C->testConnection();
		} catch(Exception $e) {
			error_log(__METHOD__.' '.$e->getMessage());
		}
        if (!empty($merchant) && !empty($pos) && !empty($salt)) {
			if ($ret['error']==0) {
				Configuration::updateValue('P24_CONFIGURED', 1);
				return true;
			}
			return false;
		}
        return null;
    }
    
    public function getCurrencyCode($currency_id) {
        $c=$this->getActualCurrencyById($currency_id);
        return $c['iso_code'];
    }
    
    public function getP24Amount($currency_id, $amount) {
        $c=$this->getActualCurrencyById($currency_id);
        if (isset($c['decimals'])&&$c['decimals']=='0') {
            if (Configuration::get('PS_PRICE_ROUND_MODE')!=null) {
                switch (Configuration::get('PS_PRICE_ROUND_MODE')) {
                    case 0:
                        $amount = ceil($amount);
                        break;
                    case 1:
                        $amount = floor($amount);
                        break;
                    case 2:
                        $amount = round($amount);
                        break;
                }
            }
        }

        return number_format($amount, 2, '.', '')*100;
    }
    
    private function getActualCurrencyById($id) {
        static $currency=null;
        if  ($currency===null) {
            $currencies = $this->getCurrency($id);
            foreach ($currencies as $c) {
                if ($c['id_currency']==$id) {
                    $currency = $c;
                    break;
                }
            }
        }
        return $currency;
    }

	private static function removeWsdlCache() {
		$dir = ini_get('soap.wsdl_cache_dir');
		$files = glob($dir.'/wsdl*');
		if ($files) {
			foreach ($files as $file) {
				try {
					if (is_writable($file)) unlink($file);
				} catch (Exception $e) {
					error_log(__METHOD__.' '.$e->getMessage());
				}
			}
		}
	}
    
    /**
     * @return string
     */
    public function getContent() {
        if (Tools::isSubmit('submit')) {
			$this->removeWsdlCache();			
            Configuration::updateValue('P24_MERCHANT_ID', trim(Tools::getValue('merchantID')));
            Configuration::updateValue('P24_SHOP_ID', trim(Tools::getValue('posID')));
            Configuration::updateValue('P24_SALT', trim(Tools::getValue('salt')));
            Configuration::updateValue('P24_TEST_MODE', Tools::getValue('test_mode'));
            Configuration::updateValue('P24_TEST_MODE_TRANSACTION', Tools::getValue('test_transaction_select'));
            Configuration::updateValue('P24_COMMISSION', 0);
            // zachowanie wstecznej zgodności z wtyczkami 1.4, 1.5
            Configuration::updateValue('P24_ORDER_STATE_1', Tools::getValue('order_state_1'));
            Configuration::updateValue('P24_ORDER_STATE_2', Tools::getValue('order_state_2'));
            
            Configuration::updateValue('P24_ONECLICK_ENABLED', Tools::getValue('oneclick_enabled')!=""?1:0);
            Configuration::updateValue('P24_API_KEY', Tools::getValue('api_key'));
            Configuration::updateValue('P24_GA_KEY', Tools::getValue('ga_key'));
            Configuration::updateValue('P24_GA_KEY_TAX', Tools::getValue('ga_key_tax')!=""?1:0);
            Configuration::updateValue('P24_BASIC_AUTH', Tools::getValue('basic_auth'));

			// ajax payment
            Configuration::updateValue('P24_PAYINSHOP_ENABLED', Tools::getValue('payinshop_enabled')!=""?1:0);
            Configuration::updateValue('P24_ACCEPTINSHOP_ENABLED', Tools::getValue('acceptinshop_enabled')!=""?1:0);

            // płatności natychmiastowe
            Configuration::updateValue('P24_PAYSLOW_ENABLED', Tools::getValue('payslow_enabled')!=""?1:0);

			// własny limit czasu
            Configuration::updateValue('P24_CUSTOM_TIMELIMIT', (int)Tools::getValue('custom_timelimit'));

			// korzystanie z IVR
			Configuration::updateValue('P24_IVR_ENABLED', Tools::getValue('ivr_enabled')!=""?1:0);

			// własny opis na liście bramek
            Configuration::updateValue("P24_CUSTOM_DESCRIPTION", Tools::getValue("custom_description"));
            
			// wybór metody płatności w sklepie
            Configuration::updateValue('P24_PAYMETHOD_LIST', Tools::getValue('payment_method_list')!=""?1:0);
            Configuration::updateValue('P24_PAYMETHOD_GRAPHICS', Tools::getValue('graphics_payment_method_list')!=""?1:0);
            Configuration::updateValue('P24_PAYMETHOD_FIRST', Tools::getValue('paymethod_first'));
            Configuration::updateValue('P24_PAYMETHOD_SECOND', Tools::getValue('paymethod_second'));

			// Wyróżnienie wybranych form płatności
            Configuration::updateValue('P24_PAYMETHOD_PROMOTE', Tools::getValue('paymethod_promote')!=""?1:0);
            Configuration::updateValue('P24_PAYMETHOD_PROMOTED', Tools::getValue('paymethod_promoted'));

			// extracharge
            Configuration::updateValue('P24_EXTRACHARGE_ENABLED', Tools::getValue('extracharge_enabled')!=""?1:0);
            Configuration::updateValue('P24_EXTRACHARGE_PRODUCT', (float)Tools::getValue('extracharge_product'));
            Configuration::updateValue('P24_EXTRACHARGE_AMOUNT', (float)Tools::getValue('increase_amount'));
            Configuration::updateValue('P24_EXTRACHARGE_PERCENT', (float)Tools::getValue('increase_percent'));
            
			// extradiscount
            Configuration::updateValue('P24_EXTRADISCOUNT_ENABLED', (int)Tools::getValue('extradiscount_enabled'));
            Configuration::updateValue('P24_EXTRADISCOUNT_AMOUNT', (float)Tools::getValue('extradiscount_amount'));
            Configuration::updateValue('P24_EXTRADISCOUNT_PERCENT', (float)Tools::getValue('extradiscount_percent'));

            Configuration::updateValue('P24_INSTALLMENT_SHOW', Tools::getValue('installment_show'));
            Configuration::updateValue('P24_ORDER_TITLE_ID', Tools::getValue('order_title_id'));
            Configuration::updateValue("P24_SHOW_SUMMARY", (Tools::getValue("show_summary")!=""?1:0));
            Configuration::updateValue("P24_DEBUG", (Tools::getValue("debug")!=""?1:0));
            Configuration::updateValue("P24_VERIFYORDER", Tools::getValue("verify_order_select"));
            $this->_displayForm(true);
        } else if (!property_exists('Przelewy24', "_html")||!$this->_html) {
            $this->_displayForm(false);
        }

        return $this->_html;
    }

    /**
     * @param bool $b_updated
     */
    private function _displayForm($b_updated = false) {
        global $cookie;

        $this->_html = '';
        //$this->_html .= $this->display(__FILE__, 'configuration.tpl');
        $module_description = html_entity_decode($this->l("You have to be registered to use module Przelewy24. If you have just done it, you can configure module in Payment Settings. However if you still have not registered, go to"));
		$p24_css = $this->p24_css;        
        $this->_html .= <<<HTML
        <style>
			@font-face {
				font-family: 'FontAwesome';
				src: url("../modules/przelewy24/css/fontawesome-webfont.eot?v=4.1.0");
				src: url("../modules/przelewy24/css/fontawesome-webfont.eot?#iefix&v=4.1.0") format("embedded-opentype"),
				     url("../modules/przelewy24/css/fontawesome-webfont.woff?v=4.1.0") format("woff"),
				     url("../modules/przelewy24/css/fontawesome-webfont.ttf?v=4.1.0") format("truetype"),
				     url("../modules/przelewy24/css/fontawesome-webfont.svg?v=4.1.0#fontawesomeregular") format("svg");
				font-weight: normal;
				font-style: normal
			}

			#content form table tr td:first-child { min-width: 250px; text-align: right; padding-right: 10px; }
			#content form table tr { height: 30px; }
			input.short { display:inline-block !important; width: 80% !important; margin-right: 20px; }
			fieldset table {   width: 100%; max-width: 640px !important; }
			fieldset table tr td:first-child { width: 35%; }
			.paylistprom_item { cursor: pointer; display: block !important; background: white; background: rgba(255,255,255,0.8); font-weight: normal !important; text-align: left; }
			
			.badge-ok, .badge-no { position: absolute; }
			.badge-ok:before,.badge-no:before, .badge-eye { font-family: FontAwesome; font-size: 2em; }
			.badge-ok:before { color: #90cb5c; content: "\\f058"; }
			.badge-no:before { color: #e17875; content: "\\f071"; }
			.badge-eye:before { color: gray; content: "\\f06e"; }
			
			span.p24info { font-size: 10px; position: relative; top: -1px; }
			span.p24info:before { content: "\\f05a"; font-family: FontAwesome; margin-right: 4px; color: #00aff0; font-size: 1.5em; position: relative; top: 1px;}

			.bank-box { transition: transform 0.2s ease,box-shadow 0.2s ease; }
			.bank-box.ui-sortable-helper { transform: rotate(10deg); box-shadow: 10px 10px 10px lightgray; }
			.bank-box.ui-unrotate-helper { transform: rotate(0deg) !important; box-shadow: 0 0 0 lightgray !important; }
        </style>
		<h2><a target="_blank" href="http://przelewy24.pl"><img src="../modules/przelewy24/img/logo.png" title="Przelewy24" alt="Przelewy24" /></a>&nbsp;{$this->l("Configuration")}</h2>
		<script type="text/javascript">
            $(function() {
                $("#test_mode").change(
                    function() {
                        var o_Test_Transaction=$("#test-transaction");

                        if($(this).val()==1) {
                            o_Test_Transaction.css("visibility","visible");
                        } else {
                            o_Test_Transaction.css("visibility","hidden");
                        }
                    }
                );
            });
       </script>
	<p style="max-width: 830px; text-align: justify;">{$module_description} <a target="_blank" href="http://www.przelewy24.pl/cms,20,rejestracja.htm">{$this->l("this link")}</a>.</p>
HTML;
        $merchantId = Configuration::get('P24_MERCHANT_ID');
        $posId = Configuration::get('P24_SHOP_ID');
        $salt = Configuration::get('P24_SALT');
        $test = Configuration::get('P24_TEST_MODE');
        $valid=$this->validateCredentials($merchantId, $posId, $salt, $test);
        $status_class = '';
        if ($valid != null) $status_class=$valid?'badge-ok':'badge-no';
        if ($b_updated) {
            if ($valid) {
				$this->_html .= <<<HTML
				<div class="alert alert-success"><button type="button" class="close" data-dismiss="alert">×</button>{$this->l("Updated")}</div>
HTML;
            } else {
                $this->_html .= <<<HTML
				<div class="alert alert-danger"><button type="button" class="close" data-dismiss="alert">×</button>{$this->l("Wrong CRC Key for this Merchant/Shop ID and module mode!")}</div>
HTML;
            }
        }
        
        $this->_html .= <<<HTML
        <form action="{$_SERVER["REQUEST_URI"]}" method="post">
            <fieldset>
                <legend><img src="../img/admin/payment.gif" /> {$this->l('Payment Settings')}</legend>
			<p><sup style="color:red">*</sup> {$this->l("mandatory")}</p>

				<table>
					<tr>
						<td><label><img src="../img/admin/tab-customers.gif" />{$this->l("Merchant ID")}<sup style="color:red">*</sup></label></td>
						<td>
							<input id="merchantID" type="text" name="merchantID" value="{$merchantId}" class="short" required/>
							<span class="{$status_class}"></span>
						</td>
                    </tr>
                    <tr>
                        <td></td>
                        <td><span class="p24info">{$this->l("Where is ID")}</span></td>
					</tr>
HTML;
        $this->_html .= <<<HTML
					<tr>
						<td><label><img src="../img/admin/tab-customers.gif" />{$this->l("Shop ID")}<sup style="color:red">*</sup></label></td>
						<td>
							<input id="posID" type="text" name="posID" value="{$posId}" class="short" required/>
							<span class="{$status_class}"></span>
						</td>
                    </tr>
                    <tr>
                        <td></td>
                        <td><span class="p24info">{$this->l("Where is ID")}</span></td>
					</tr>
HTML;
        $this->_html .= <<<HTML
					<tr>
						<td><label><img src="../img/admin/tab-customers.gif" />{$this->l("CRC Key")}<sup style="color:red">*</sup></label></td>
						<td>
							<input id="salt" type="text" name="salt" value="{$salt}" class="short" required/>
							<span class="{$status_class}"></span>
						</td>
                    </tr>
                    <tr>
                        <td></td>
                        <td><span class="p24info">{$this->l("Where is CRC")}</span></td>
					</tr>
HTML;
        $order_title_id_0_selected = ((Configuration::get('P24_ORDER_TITLE_ID')==0)?' selected="selected"':'');
        $order_title_id_1_selected = ((Configuration::get('P24_ORDER_TITLE_ID')==1)?' selected="selected"':'');
        $this->_html .= <<<HTML
					<tr>
						<td><label for="order_title_id">{$this->l('Order id in title')}</label></td>
						<td>
							<select id="order_title_id" name="order_title_id">
								<option value="0"{$order_title_id_0_selected}>{$this->l("Order id in database (e.g. 1, 2, 3)")}</option>
								<option value="1"{$order_title_id_1_selected}>{$this->l("Masked order id (e.g. QYTUVLHOW)")}</option>
							</select>
						</td>
					</tr>
HTML;
        $show_summary_checked = ((Configuration::get('P24_SHOW_SUMMARY')==1)?' checked="checked"':'');
        $this->_html .= <<< HTML
		            <tr>
		                <td><label for="show_summary"><h5 style="display: inline">{$this->l("Show summary on confirmation page")}</h5></label></td>
		                <td><input type="checkbox" name="show_summary" id="show_summary"{$show_summary_checked} /></td>
		            </tr>
					<tr>
						<td><label>{$this->l('Status before completing payment')}</label></td>
						<td>
							<select name="order_state_1">
HTML;

        foreach (OrderState::getOrderStates($cookie->id_lang) as $orderState) {
            $selected = (Configuration::get('P24_ORDER_STATE_1')==$orderState['id_order_state'])?' selected="selected"':'';
            $this->_html .= <<<HTML
				<option value="{$orderState['id_order_state']}"{$selected}>{$orderState['name']}</option>';
HTML;
        }
        $this->_html .= <<<HTML
							</select>
						</td>
					</tr>
					<tr>
						<td><label>{$this->l('Status after completing payment')}</label></td>
						<td>
							<select name="order_state_2">
HTML;
        foreach (OrderState::getOrderStates($cookie->id_lang) as $orderState) {
            $selected = (Configuration::get('P24_ORDER_STATE_2')==$orderState['id_order_state'])?' selected="selected"':'';
            $this->_html .= <<<HTML
								<option value="{$orderState['id_order_state']}"{$selected}>{$orderState['name']}</option>';
HTML;
        }
        $this->_html .= <<<HTML
							</select>
						</td>
					</tr>
HTML;
        $test_mode_1_selected = (($test==1)?' selected="selected"':'');
        $test_mode_2_selected = (($test==0)?' selected="selected"':'');
        $this->_html .= <<<HTML
					<tr>
						<td><label>{$this->l('Module mode')}</label></td>
						<td>
                            <select name="test_mode" id="test_mode">
                                    <option value="1"{$test_mode_1_selected}>{$this->l('test')}</option>
                                    <option value="0"{$test_mode_2_selected}>{$this->l('normal')}</option>
                            </select>
                        </td>
					</tr>
HTML;
        $verify_order_2_select = ((Configuration::get('P24_VERIFYORDER')==2)?' selected="selected"':'');
        $verify_order_1_select = ((Configuration::get('P24_VERIFYORDER')==1)?' selected="selected"':'');
        $verify_order_0_select = ((Configuration::get('P24_VERIFYORDER')==0)?' selected="selected"':'');

        $test_transaction_1_select = ((Configuration::get('P24_TEST_MODE_TRANSACTION')==1)?' selected="selected"':'');
        $test_transaction_0_select = ((Configuration::get('P24_TEST_MODE_TRANSACTION')==0)?' selected="selected"':'');
        $test_transaction_visible = ((Configuration::get('P24_TEST_MODE')==1)?'visible':'hidden');
        $this->_html .= <<<HTML
					<tr>
						<td id="verify-order">
							<label for="verify_order_select"><h5 style="display: inline">{$this->l('Order validation (change cart to order):')}</h5></label>
                        </td>
						<td>
                            <select name="verify_order_select" id="verify_order_select">
                                    <option value="0"{$verify_order_0_select}>{$this->l('transaction verification')}</option>
                                    <option value="1"{$verify_order_1_select}>{$this->l('order confirmation')}</option>
                                    <option value="2"{$verify_order_2_select}>{$this->l('after click Confirm button')}</option>
                            </select>
                        </td>
					</tr>
HTML;
$debug_checked = ((Configuration::get('P24_DEBUG')==1)?' checked="checked"':'');
        $this->_html .= <<< HTML
		            <tr>
		                <td><label for="debug"><h5 style="display: inline">{$this->l("Debug mode")}</h5></label></td>
		                <td><input type="checkbox" name="debug" id="debug"{$debug_checked} /></td>
		            </tr>
				</table>
        </fieldset>
HTML;

		$ga_key = Configuration::get('P24_GA_KEY');
		$ga_key_tax_checked = ((Configuration::get('P24_GA_KEY_TAX')==1)?' checked="checked"':'');
		$validateGA = $this->validateGA($ga_key);
		$status_ga_class = '';
		if ($ga_key) {
			$status_ga_class = $validateGA ? 'badge-ok' : 'badge-no';
		}


		$api_key = Configuration::get('P24_API_KEY');
        $status_api_class = '';
		$apiTestAccess = false;
		if (!empty($api_key)) {
			$apiTestAccess = $this->apiTestAccess();
			$status_api_class = $apiTestAccess ? 'badge-ok' : 'badge-no';
		}

		$basic_auth = Configuration::get('P24_BASIC_AUTH');
        $this->_html .= <<< HTML
            <fieldset>
                <legend><img src="../img/admin/payment.gif" /> {$this->l('Keys')}</legend>

				<table>
					<tr>
						<td><label for="api_key">{$this->l("API Key")}</label></td>
						<td>
							<input type="text" name="api_key" id="api_key" class="short" value="{$api_key}" />
							<span class="{$status_api_class}"></span>
						</td>
					</tr>
					<tr>
						<td></td>
						<td><span class="p24info">{$this->l("Where is API")}</span></td>
					</tr>
					<tr>
						<td><label for="ga_key"><h5>{$this->l("GA Key")}</h5></label></td>
						<td>
							<input type="text" name="ga_key" id="ga_key" class="short" value="{$ga_key}" placeholder="UA-XXXXXXXX-X"/>
							<span class="{$status_ga_class}"></span>
						</td>
					</tr>
					<tr>
						<td><label for="ga_key_tax"><h5>{$this->l("Send to GA with tax")}</h5></label></td>
						<td><input type="checkbox" name="ga_key_tax" id="ga_key_tax"{$ga_key_tax_checked} /></td>
					</tr>
					<tr>
						<td><label for="basic_auth"><h5>{$this->l("Basic auth")}</h5></label></td>
						<td>
							<span class="badge-eye" onclick="$('#basic_auth').css('visibility','visible'); $(this).hide();" style="cursor:pointer"></span>
							<input type="text" name="basic_auth" id="basic_auth" class="short" value="{$basic_auth}" placeholder="login:password" style="visibility:hidden" />
						</td>
					</tr>
					<tr>
						<td></td>
						<td>
							<span class="p24info">{$this->l("Fill in this field if Your shop is protected with basic-auth mechanism")}</span>
						</td>
					</tr>
                    
				</table>
        </fieldset>
HTML;
		if ($apiTestAccess && $this->ccCheckRecurrency()) {
			$oneclick_enabled_checked = ((Configuration::get('P24_ONECLICK_ENABLED')==1)?' checked="checked"':'');
			$payinshop_enabled_checked = ((Configuration::get('P24_PAYINSHOP_ENABLED')==1)?' checked="checked"':'');
					$this->_html .= <<<HTML
			<fieldset>
				<legend><img src="../img/admin/payment.gif" /> {$this->l("Oneclick payments")}</legend>
				<table>
					<tr>
						<td><label for="oneclick_enabled"><h5>{$this->l("Oneclick payments")}</h5></label></td>
						<td><input type="checkbox" name="oneclick_enabled" id="oneclick_enabled"{$oneclick_enabled_checked} /></td>
					</tr>
					<tr>
						<td><label for="payinshop_enabled"><h5>{$this->l("Pay in shop")}</h5></label></td>
						<td>
							<input type="checkbox" name="payinshop_enabled" id="payinshop_enabled"{$payinshop_enabled_checked} />
							<span class="p24info">{$this->l("Pay in shop description")}</span>
						</td>
					</tr>
				</table>
			</fieldset>
HTML;
		}
        $acceptinshop_enabled_checked = ((Configuration::get('P24_ACCEPTINSHOP_ENABLED')==1)?' checked="checked"':'');
        $payslow_enabled_checked = ((Configuration::get('P24_PAYSLOW_ENABLED')==1)?' checked="checked"':'');
        $custom_timelimit = Configuration::get('P24_CUSTOM_TIMELIMIT');
        if ($custom_timelimit === '') $custom_timelimit = 15;

        $ivr_enabled_checked = ((Configuration::get('P24_IVR_ENABLED')==1)?' checked="checked"':'');

        $installment_2_show = ((Configuration::get('P24_INSTALLMENT_SHOW')==2)?' selected="selected"':'');
        $installment_1_show = ((Configuration::get('P24_INSTALLMENT_SHOW')==1)?' selected="selected"':'');
        $installment_0_show = ((Configuration::get('P24_INSTALLMENT_SHOW')==0)?' selected="selected"':'');
        $this->_html .= <<<HTML
        <fieldset>
        	<legend><img src="../img/admin/payment.gif" /> {$this->l("Payment Settings")}</legend>
        	<table>
        		<tr>
        			<td><label for="acceptinshop_enabled"><h5>{$this->l("Show accept button in shop")}</h5></label></td>
        			<td>
						<input type="checkbox" name="acceptinshop_enabled" id="acceptinshop_enabled"{$acceptinshop_enabled_checked} />
						<span class="p24info">{$this->l("Show accept button in shop description")}</span>
					</td>
        		</tr>
                <tr>
                    <td><label for="installment_show"><h5 style="display:inline">{$this->l('Installment Settings')}</h5></label></td>
                    <td>
                        <select name="installment_show" id="installment_show">
                            <option value="2"{$installment_2_show}>{$this->l('button (payment page) and information (product page)')}</option>
                            <option value="1"{$installment_1_show}>{$this->l('button (payment page) only')}</option>
                            <option value="0"{$installment_0_show}>{$this->l('hide all')}</option>
                        </select>
                    </td>
                </tr>
        		<tr>
        			<td><label for="payslow_enabled"><h5>{$this->l("Allow also for not immediate payments")}</h5></label></td>
        			<td>
						<input type="checkbox" name="payslow_enabled" id="payslow_enabled"{$payslow_enabled_checked} />
						<span class="p24info">{$this->l("This setting increases the number of available payment methods")}</span>
					</td>
        		</tr>
        		<tr>
        			<td><h5>{$this->l("Adjust the time limit for completion of the transaction")}</h5></td>
        			<td>
						<div class="input-group col-lg-2">
						<input type="number" name="custom_timelimit" id="custom_timelimit" min="0" max="99" style="width: 70px;" value="{$custom_timelimit}" class="form-control"/>
						<span class="input-group-addon">min</span>
						</div>
					</td>
        		</tr>
        		<tr>
					<td></td>
					<td><span class="p24info">{$this->l("Value 0 means no time limit")}</span></td>
        		</tr>
HTML;
		if ($apiTestAccess && $this->checkIvrPresent()) {
        $this->_html .= <<<HTML
        		<tr>
        			<td><h5>{$this->l("Show IVR button at Order Details page")}</h5></td>
        			<td>
						<input type="checkbox" name="ivr_enabled" id="payslow_enabled"{$ivr_enabled_checked} />
						<span class="p24info">{$this->l("This button allows to call back to the Customer")}</span>
					</td>
        		</tr>
HTML;
		}
		$custom_description = Configuration::get('P24_CUSTOM_DESCRIPTION');
        $this->_html .= <<<HTML
        		<tr>
        			<td><h5>{$this->l("Custom module description")}</h5></td>
        			<td>
						<input type="text" name="custom_description" id="custom_description" value="{$custom_description}" />
					</td>
        		</tr>
        	</table>
        </fieldset>
HTML;

	if ($apiTestAccess) {
		$payment_method_list_checked = '';
		$paymethod_style = 'display:none;';
		if (Configuration::get('P24_PAYMETHOD_LIST')==1) {
			$payment_method_list_checked = ' checked="checked"';
			$paymethod_style = '';
		}
        $graphics_payment_method_list_checked = ((Configuration::get('P24_PAYMETHOD_GRAPHICS')==1)?' checked="checked"':'');
		$payment_list_res = $this->availablePaymentMethods(false);
		$payment_list = array();
		if (is_array($payment_list_res)) {
			foreach ($payment_list_res as $item) {
				$payment_list[$item->id] = $item;
			}
		}
		
		$html_selected = '';
		$html_available = '';

		$P24_PAYMETHOD_FIRST = explode(',',Configuration::get('P24_PAYMETHOD_FIRST'));
		$P24_PAYMETHOD_SECOND = explode(',',Configuration::get('P24_PAYMETHOD_SECOND'));

		function getBankHtml($bank) {
			return '<a class="bank-box" data-id="'.$bank->id.'"><div class="bank-logo bank-logo-'.$bank->id.'"></div><div class="bank-name">'.$bank->name.'</div></a>';
		}

		foreach ($P24_PAYMETHOD_FIRST as $id) {
			if (isset($payment_list[$id])) {
				$html_selected .= getBankHtml($payment_list[$id]);
				unset($payment_list[$id]);
			}
		}

		foreach ($P24_PAYMETHOD_SECOND as $id) {
			if (isset($payment_list[$id])) {
				$html_available .= getBankHtml($payment_list[$id]);
				unset($payment_list[$id]);
			}
		}

		foreach ($payment_list as $id => $bank) {
			$html_available .= getBankHtml($bank);
		}

		$maxNo = 5;
		$drop_here_translation = sprintf($this->l('Drop here max. %s payment methods'),$maxNo);
        $this->_html .= <<<HTML
		<style>
			.paymethod .selected {
				width: 730px;
				border: 5px dashed lightgray;
				height: 101px;
				padding: 0.5em;
				overflow: hidden;
			}
			.bank-placeholder { opacity: 0.6; }
			.sortable.available .bank-box:last-child { clear: both; }
  		</style>
        <fieldset>
        	<legend><img src="../img/admin/payment.gif" /> {$this->l("Payment methods")}</legend>
        	<table>
        		<tr>
        			<td><label for="payment_method_list"><h5>{$this->l("Show available payment methods in shop")}</h5></label></td>
        			<td>
						<input type="checkbox" name="payment_method_list" id="payment_method_list"{$payment_method_list_checked} />
						<span class="p24info">{$this->l("Customer can chose payment method on confirmation page")}</span>
					</td>
        		</tr>
            </table>
            <input type="hidden" name="paymethod_first"  id="paymethod_first">
            <input type="hidden" name="paymethod_second" id="paymethod_second">

			<div class="paymethod" style="{$paymethod_style}">

				<table>
					<tr>
						<td><label for="graphics_payment_method_list"><h5>{$this->l("Use graphics list of payment methods")}</h5></label></td>
						<td>
							<input type="checkbox" name="graphics_payment_method_list" id="graphics_payment_method_list"{$graphics_payment_method_list_checked} />
						</td>
					</tr>
					<tr>
						<td></td>
						<td>
							<button type="button" onClick="setAutoOrder()">{$this->l("Set the payment methods order of the most used")}</button>
						</td>
					</tr>
				</table>

				<div style="margin-left: 2em;">
					<p style="margin: 1em 0 0 0;">{$this->l("Payment methods visible right away:")} ({$drop_here_translation})</p>
					<div class="sortable selected" style="float: left" data-max="{$maxNo}">{$html_selected}</div>
					<img src="../modules/przelewy24/img/arrow-left-icon.png" style="display: inline-block; opacity: 0.3;position: relative; top: 30px; left: 7px;">
					<p style="margin: 1em 0 0 0; clear: both;">{$this->l("Payment methods visible on more-button:")}</p>
					<div class="sortable available">{$html_available} <div style="clear:both" id="clear"></div></div>
					<div class="tempHolder"></div>
				</div>
			</div>
        </fieldset>
		<script>
			function setAutoOrder() {
				$.ajax('{$this->context->link->getModuleLink('przelewy24', 'paymentAjax', array(), Configuration::get('PS_SSL_ENABLED') == 1)}', {
					method: 'POST', type: 'POST',
					data : { action: 'setOrder' },
					success : function(data) {
						$('.paymethod .selected a.bank-box,.paymethod .available a.bank-box').appendTo('.paymethod .tempHolder');
						var order = JSON.parse(data);
						var counter = 0;
						for (var i in order) {
							counter++;
							if (counter < 4) {
								$('.paymethod .tempHolder a.bank-box[data-id=' + order[i] + ']').appendTo('.paymethod .selected');
							} else {
								$('.paymethod .tempHolder a.bank-box[data-id=' + order[i] + ']').appendTo('.paymethod .available');
							}
						};
						$('.paymethod .tempHolder a.bank-box').appendTo('.paymethod .available');
						$('#clear').appendTo('.paymethod .available');
						$('.paymethod .selected,.paymethod .available')
							.css({ backgroundColor : "#FEFCD7" })
							.animate({ backgroundColor : "#fff" }, 2000)
						;
						updatePaymethods();
					},
				});
			}
			function updatePaymethods() {
				$('.bank-box.ui-unrotate-helper').removeClass('ui-unrotate-helper');
				var maxNo = parseInt($('.paymethod .selected').attr('data-max'));
				if (maxNo > 0) {
					if ($('.paymethod .selected a[data-id]').length > maxNo) {
						var i = 0;
						$('.paymethod .selected a[data-id]').each(function(){
							i++;
							if (i > maxNo) {
								$(this).prependTo($('.paymethod .available'));
								$('#clear').appendTo('.paymethod .available');
							}
						});
					}
				}
			
				$('#paymethod_first').val('');
				$('.paymethod .selected a[data-id]').each(function(){
					$('#paymethod_first').val($('#paymethod_first').val() + ($('#paymethod_first').val().length ?',':'') + $(this).attr('data-id'));
				});

				$('#paymethod_second').val('');
				$('.paymethod .available a[data-id]').each(function(){
					$('#paymethod_second').val($('#paymethod_second').val() + ($('#paymethod_second').val().length ?',':'') + $(this).attr('data-id'));
				});
			}
			$(document).ready(function(){
				updatePaymethods();
				$('#payment_method_list').change(function(){
					if ($(this).is(":checked")) {
						$('.paymethod:not(:visible)').slideDown(400, function(){ $('body').animate({ scrollTop: $(window).scrollTop() + $('.paymethod').height() }) });
					} else {
						$('.paymethod:visible').slideUp();
					}
				});
			});
		</script>
HTML;

		$promote_enabled_checked = ((Configuration::get('P24_PAYMETHOD_PROMOTE')==1)?' checked="checked"':'');
		$paymethod_promoted = Configuration::get('P24_PAYMETHOD_PROMOTED');
		$paymethod_promoted_ar = explode(',',$paymethod_promoted);
		$paymethod_promote_list_style = 'display:none';
		if (Configuration::get('P24_PAYMETHOD_PROMOTE')==1) {
			$paymethod_promote_list_style = '';
		}

		$paymentListToPromote = array();
		if (is_array($payment_list_res)) {
			foreach ($payment_list_res as $item) {
				if (!in_array($item->id, array(129,140,142,145,2000))) { // bez kart i rat, bez przedpłaty
					$item->checked = '';
					if (in_array($item->id, $paymethod_promoted_ar)) {
						$item->checked = ' checked="checked"';
					}
					$paymentListToPromote[] = $item;
				}
			}
		}

		$payment_list_promote = '';
		foreach ($paymentListToPromote as $item) {
			$payment_list_promote .= "<label class=\"paylistprom_item paylistprom_item_{$item->id}\"
				for=\"paylistprom_{$item->id}\"><span
				style=\"cursor: ns-resize; display: inline-block\" class=\"ui-icon ui-icon-grip-dotted-vertical\"></span><input
				class=\"paylistprom\" id=\"paylistprom_{$item->id}\" type=\"checkbox\" data-val=\"{$item->id}\" {$item->checked}> <span
				style=\"position:relative; top: -2px\">{$item->name}</span></label>";
		}
		
		$this->_html .= <<<HTML
        <fieldset>
        	<legend><img src="../img/admin/payment.gif" /> {$this->l("Additional settings")}</legend>
        	<table>
        		<tr>
        			<td><label for="paymethod_promote"><h5>{$this->l("Promote some payment methods")}</h5></label></td>
        			<td>
						<input type="checkbox" name="paymethod_promote" id="paymethod_promote" {$promote_enabled_checked} />
						<span class="p24info">{$this->l("Selected items will be shown next to other payments gateways")}</span>
					</td>
        		</tr>
        		<tr>
        			<td></td>
        			<td>
						<input type="hidden" name="paymethod_promoted" id="paymethod_promoted" value="{$paymethod_promoted}" />
						<div id="paymethod_promote_list" style="{$paymethod_promote_list_style}">
							{$payment_list_promote}
						</div>
					</td>
        		</tr>
        	</table>
        </fieldset>

		<script>
			function updatePaymethodPromoted() {
				var paymethod_promoted = [];
				$('.paylistprom:checked').each(function() {
					paymethod_promoted.push($(this).attr('data-val'));
				});
				$('#paymethod_promoted').val(paymethod_promoted.join(','));
			}
			$(document).ready(function(){
				$('head').append('<link rel="stylesheet" href="{$p24_css}" type="text/css" />');
				$('head').append('<link rel="stylesheet" href="//ajax.googleapis.com/ajax/libs/jqueryui/1.8/themes/smoothness/jquery.ui.all.css" type="text/css" />');
				$.getScript("//ajax.googleapis.com/ajax/libs/jqueryui/1/jquery-ui.min.js",
					function() {
						$(".sortable.selected,.sortable.available").sortable({
							connectWith: ".sortable.selected,.sortable.available",
							placeholder: "bank-box bank-placeholder",
							stop: function(){ updatePaymethods(); },
							revert: true,
							start: function(){
								window.setTimeout(function(){
									$('.bank-box.ui-sortable-helper').on('mouseup', function(){
										$(this).addClass('ui-unrotate-helper');
									});
								});
							},
						}).disableSelection();
						
						$("#paymethod_promote_list")
							.sortable({
								stop: function() { updatePaymethodPromoted(); },
								axis: 'y',
							})
							.disableSelection()
						;
					}
				);
				$('.paylistprom').change(function(){
					updatePaymethodPromoted();
				});
				$('#paymethod_promote').change(function(){
					if ($(this).is(":checked")) {
						$('#paymethod_promote_list:not(:visible)').slideDown(400, function(){ $('body').animate({ scrollTop: $('#paymethod_promote_list').closest('fieldset').offset().top - $('.page-head').height() - 10 }) });
					} else {
						$('#paymethod_promote_list:visible').slideUp();
					}
				});
				var paymethod_promoted = $('#paymethod_promoted').val().split(',').reverse();
				if (paymethod_promoted.length > 0) {
					for (i in paymethod_promoted) {
						$('.paylistprom_item_' + paymethod_promoted[i]).prependTo('#paymethod_promote_list');
					}
				}
			});
		</script>

HTML;
		}


		$extracharge_enabled_checked = ((Configuration::get('P24_EXTRACHARGE_ENABLED')==1)?' checked="checked"':'');
		$currency = Context::getContext()->currency->iso_code;
		$increase_amount  = Configuration::get('P24_EXTRACHARGE_AMOUNT');
		$increase_percent = Configuration::get('P24_EXTRACHARGE_PERCENT');

		// przygotowywanie listy produktów wirtualnych
		$extracharge_product = Configuration::get('P24_EXTRACHARGE_PRODUCT');
		$id_lang = Context::getContext()->language->id;
		$product_list_res = Product::getProducts($id_lang, 0, 999, "is_virtual", "desc");
		$product_list = array();
		foreach ($product_list_res as $k => $item) {
			if ($item['is_virtual'] == 1) {
				$product_list[$item['id_product']] = $item['name'];
			}
		}
		asort($product_list);
		$extracharge_product_select = '<option value="0">-- '.$this->l("Chose virtual product").' --</option>';
		foreach($product_list as $id_product => $name_product) {
			$extracharge_product_select .= "<option value=\"{$id_product}\" ".($id_product == $extracharge_product ? ' selected="selected"' : '').">{$name_product}</option>";
		}
		
		$this->_html .= <<<HTML
        <fieldset>
        	<legend><img src="../img/admin/payment.gif" /> {$this->l("Extra charge settings")}</legend>
        	<table>
        		<tr>
        			<td><label for="extracharge_enabled"><h5>{$this->l("Enable extra charge")}</h5></label></td>
        			<td>
						<input type="checkbox" name="extracharge_enabled" id="extracharge_enabled"{$extracharge_enabled_checked} />
					</td>
        		</tr>
        		<tr>
        			<td><label for="extracharge_enabled"><h5>{$this->l("Chose virtual product")}</h5></label></td>
        			<td>
						<select name="extracharge_product">{$extracharge_product_select}</select>
					</td>
        		</tr>
        		<tr>
        			<td></td>
        			<td><span class="p24info">{$this->l("This product will be added to the invoice in price (with tax) as below.")}</span></td>
        		</tr>
        		<tr>
        			<td>{$this->l("Increase payment (amount)")}</td>
        			<td>
						<div class="input-group col-lg-2">
						<input type="number" min="0" max="9999" step="0.01" name="increase_amount" id="increase_amount" style="width: 70px;" value="{$increase_amount}"  class="form-control"/>
						<span class="input-group-addon">{$currency}</span>
						</div>
					</td>
        		</tr>
        		<tr>
        			<td>{$this->l("Increase payment (percent)")}</td>
        			<td>
						<div class="input-group col-lg-2">
						<input type="number" min="0" max="100" step="0.01" pattern="[0-9]+\.\d{2}" name="increase_percent" id="increase_percent" style="width: 70px;" value="{$increase_percent}"  class="form-control"/>
						<span class="input-group-addon">%</span>
						</div>
					</td>
        		</tr>
        		<tr>
        			<td></td>
        			<td><span class="p24info">{$this->l("Extra charge description")}</span></td>
        		</tr>
        	</table>
        </fieldset>
HTML;

		$extradiscount = Configuration::get('P24_EXTRADISCOUNT_ENABLED');
		$extradiscount_amount  = Configuration::get('P24_EXTRADISCOUNT_AMOUNT');
		$extradiscount_percent = Configuration::get('P24_EXTRADISCOUNT_PERCENT');

		$extradiscount_selected = array('','','');
		$extradiscount_selected[$extradiscount] = ' selected="selected" ';

		$this->_html .= <<<HTML
        <fieldset>
        	<legend><img src="../img/admin/payment.gif" /> {$this->l("Extra discount settings")}</legend>
        	<table>
        		<tr>
        			<td><label for="extradiscount_enabled"><h5>{$this->l("Enable extra discount")}</h5></label></td>
        			<td>
						<select name="extradiscount_enabled" onChange="var c='.extradiscount-'+$(this).val();$('.extradiscount:not('+c+')').hide().find('input').val('');$(c).show()">
							<option value="0" {$extradiscount_selected[0]}>{$this->l("Discount disabled")}</option>
							<option value="1" {$extradiscount_selected[1]}>{$this->l("Discount amount")}</option>
							<option value="2" {$extradiscount_selected[2]}>{$this->l("Discount percent")}</option>
						</select>
					</td>
        		</tr>
        		<tr>
        			<td></td>
        			<td><span class="p24info">{$this->l("It allows for an additional discount if the customer uses Przelewy24")}</span></td>
        		</tr>
        		<tr class="extradiscount extradiscount-1" style="display:none">
        			<td>{$this->l("Discount amount")}</td>
        			<td>
						<div class="input-group col-lg-2">
						<input type="number" min="0" max="9999" step="0.01" name="extradiscount_amount" id="extradiscount_amount" style="width: 70px;" value="{$extradiscount_amount}" class="form-control"/>
						<span class="input-group-addon">{$currency}</span>
						</div>
					</td>
        		</tr>
        		<tr class="extradiscount extradiscount-2" style="display:none">
        			<td>{$this->l("Discount percent")}</td>
        			<td>
						<div class="input-group col-lg-2">
						<input type="number" min="0" max="100" step="0.01" pattern="[0-9]+\.\d{2}" name="extradiscount_percent" id="extradiscount_percent" style="width: 70px;" value="{$extradiscount_percent}"  class="form-control"/>
						<span class="input-group-addon">%</span>
						</div>
					</td>
        		</tr>
        	</table>
        </fieldset>
        <script>$(document).ready(function(){ $('[name=extradiscount_enabled]').trigger('change'); });</script>
HTML;

		$this->_html .= <<<HTML
        <input type="submit" name="submit" value="{$this->l('Save settings')}" class="button" />
    </form>
HTML;
    }

    /**
     * @return bool
     */
    public function install() {
        if (_PS_VERSION_>=1.5) {
            parent::install();
            $tableName = _DB_PREFIX_.'p24_recuring';
            $recsql=<<<SQLTEXT
CREATE TABLE IF NOT EXISTS `{$tableName}` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `website_id` INT NOT NULL,
  `customer_id` INT NOT NULL,
  `reference_id` VARCHAR(35) NOT NULL,
  `expires` VARCHAR(4) NOT NULL,
  `mask` VARCHAR (32) NOT NULL,
  `card_type` VARCHAR (20) NOT NULL,
  `timestamp` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
PRIMARY KEY (`id`),
  UNIQUE KEY `UNIQUE_FIELDS` (`mask`,`card_type`,`expires`,`customer_id`,`website_id`)
) ENGINE = InnoDB;
SQLTEXT;
            Db::getInstance()->Execute($recsql);

            $lang_table = Db::getInstance()->ExecuteS('SELECT `id_lang` FROM `'._DB_PREFIX_.'lang`');
            foreach ($lang_table as $langItem) {
				$langId = (int)$langItem['id_lang'];
				$rq = Db::getInstance()->getRow('SELECT `id_order_state` FROM `'._DB_PREFIX_.'order_state_lang`	WHERE id_lang = \''.$langId.'\' AND  name = \''.pSQL('Oczekiwanie na płatność Przelewy24').'\'');
				if ($rq&&isset($rq['id_order_state'])&&intval($rq['id_order_state'])>0) {
					define('P24_ORDER_STATE_1', $rq['id_order_state']);
					Configuration::updateValue('P24_ORDER_STATE_1', $rq['id_order_state']);
				} else {
					Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'order_state` (`unremovable`, `color`) VALUES(1, \'lightblue\')');
					$stateid = Db::getInstance()->Insert_ID();
					Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'order_state_lang` (`id_order_state`, `id_lang`, `name`, `template`) VALUES('.intval($stateid).', '.$langId.', \'Oczekiwanie na płatność Przelewy24\',\'\')');

					define('P24_ORDER_STATE_1', $stateid);
					Configuration::updateValue('P24_ORDER_STATE_1', $stateid);
				}
				
				$rq = Db::getInstance()->getRow('SELECT `id_order_state` FROM `'._DB_PREFIX_.'order_state_lang`	WHERE id_lang = \''.$langId.'\' AND  name = \''.pSQL('Płatność Przelewy24 przyjęta').'\'');
				if ($rq&&isset($rq['id_order_state'])&&intval($rq['id_order_state'])>0) {
					define('P24_ORDER_STATE_2', $rq['id_order_state']);
					Configuration::updateValue('P24_ORDER_STATE_2', $rq['id_order_state']);
				} else {
					Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'order_state` (`unremovable`, `color`, `paid`, `invoice`) VALUES(1, \'Limegreen\', 1, 1)');
					$stateid = Db::getInstance()->Insert_ID();
					Db::getInstance()->Execute('INSERT INTO `'._DB_PREFIX_.'order_state_lang` (`id_order_state`, `id_lang`, `name`, `template`) VALUES('.intval($stateid).', '.$langId.', \'Płatność Przelewy24 przyjęta\',\'payment\')');
					define('P24_ORDER_STATE_2', $stateid);
					Configuration::updateValue('P24_ORDER_STATE_2', $stateid);
				}
			}


            if (   !$this->registerHook('displayPayment')
				|| !$this->registerHook('displayOrderDetail')
				|| !$this->registerHook('displayRightColumnProduct')
				|| !$this->registerHook('displayCustomerAccount')
				|| !$this->registerHook('displayHeader')
				|| !$this->registerHook('displayBackOfficeTop')
				|| !$this->registerHook('displayInvoice')
				|| !$this->createAmountTable()
				|| !$this->createLastPaymentMethodTable()
				|| !$this->createCustomerSettingsTable()
			) {
                return false;
            }
            return true;
        } else {
            parent::uninstall();
            return false;
        }
    }

    /**
     * @return bool
     */
    private function createAmountTable() {
        Db::getInstance()->Execute('CREATE TABLE IF NOT EXISTS`'._DB_PREFIX_.'przelewy24_amount` (
			`i_id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`s_sid`	char(32) NOT NULL,
			`i_id_order` INT UNSIGNED NOT NULL ,
			`i_amount` INT UNSIGNED NOT NULL
			);');

		/* backwards compatibility */
        $has_field_p24_method = Db::getInstance()->getRow("SELECT EXISTS(
			SELECT * FROM information_schema.columns
			WHERE table_schema = database()
			AND COLUMN_NAME = 'p24_method'
			AND table_name = '"._DB_PREFIX_."przelewy24_amount') AS jest");
		if (!$has_field_p24_method) {
			Db::getInstance()->Execute('ALTER TABLE '._DB_PREFIX_.'przelewy24_amount ADD COLUMN p24_method INT;');
		}
        return true;
    }

    private function createLastPaymentMethodTable() {
        Db::getInstance()->Execute('CREATE TABLE IF NOT EXISTS`'._DB_PREFIX_.'przelewy24_lastmethod` (
			`customer_id` INT NOT NULL PRIMARY KEY,
			`p24_method` INT NOT NULL
			);');
        return true;
    }
    private function createCustomerSettingsTable() {
        Db::getInstance()->Execute('CREATE TABLE IF NOT EXISTS`'._DB_PREFIX_.'przelewy24_customersettings` (
			`customer_id` INT NOT NULL PRIMARY KEY,
			`cc_forget` INT DEFAULT 0
			);');
        return true;
    }

    public function hookDisplayPayment() {
        global $smarty, $cart;
        
        $currency = $this->getCurrencyCode($cart->id_currency);
		if(empty($currency)) return;
        
        $amount = $cart->getOrderTotal(true, Cart::BOTH);
        $protocol = Przelewy24::getHttpProtocol();

        $smarty->assign('p24_url', $protocol.htmlspecialchars($_SERVER['HTTP_HOST'], ENT_COMPAT, 'UTF-8').__PS_BASE_URI__);
        $smarty->assign('ps_version',_PS_VERSION_);
        
        $p24_url_payment = $this->context->link->getModuleLink('przelewy24', 'paymentConfirmation', array(), Configuration::get('PS_SSL_ENABLED') == 1);
        $smarty->assign('p24_url_payment', $p24_url_payment);
        $smarty->assign('p24_channels_raty', $this->getChannelsRaty());
        $smarty->assign('p24_installment_show', 0);
        if ($amount>=300 && Configuration::get('P24_INSTALLMENT_SHOW') > 0) {
            $smarty->assign('p24_installment_show', Configuration::get('P24_INSTALLMENT_SHOW'));
			$need_payment_list = true;
        }
		if (Configuration::get('P24_PAYMETHOD_PROMOTE')==1 && $currency == 'PLN') {
			$paymethod_promoted = Configuration::get('P24_PAYMETHOD_PROMOTED');
			$paymethod_promoted_ar = explode(',',$paymethod_promoted);
			$smarty->assign('p24_paymethod_promoted', $paymethod_promoted_ar);
			$need_payment_list = true;
		}

		if ($need_payment_list) {
			$payment_list_res = $this->availablePaymentMethods(Configuration::get('P24_PAYSLOW_ENABLED')!=1, $currency);
			$payment_list = array();
			if (is_array($payment_list_res)) {
				foreach ($payment_list_res as $item) {
					$payment_list[$item->id] = $item;
				}
			}

			$smarty->assign('p24_payment_list', $payment_list);
		}
		$smarty->assign('p24_custom_description', Configuration::get('P24_CUSTOM_DESCRIPTION'));

        return $this->display(__FILE__, 'payment.tpl');
    }

	public static function requestGet($url) {
		$isCurl = function_exists('curl_init')&&function_exists('curl_setopt')&&function_exists('curl_exec')&&function_exists('curl_close');

		if ($isCurl) {
			$userAgent = "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)";
			$curlConnection = curl_init();
			curl_setopt($curlConnection, CURLOPT_URL, $url);
			curl_setopt($curlConnection, CURLOPT_SSL_VERIFYHOST, 2);
			curl_setopt($curlConnection, CURLOPT_USERAGENT, $userAgent);
			curl_setopt($curlConnection, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($curlConnection, CURLOPT_SSL_VERIFYPEER, false);
			$result = curl_exec($curlConnection);
			curl_close($curlConnection);
			return $result;
		}
		return "";
	}

    public function hookDisplayRightColumnProduct() {
        global $smarty, $cookie;
        if (Configuration::get('P24_INSTALLMENT_SHOW')==2) {
            $productID = Tools::getValue('id_product');

            if (isset($productID)&&$productID!='') {
                $product = new Product((int)$productID, true, $cookie->id_lang);
                $amount = $product->getPrice(true, null, 2, null, false, true, 1);
                $context = Context::getContext();
                $id_currency = (int)Validate::isLoadedObject($context->currency) ? $context->currency->id : Configuration::get('PS_CURRENCY_DEFAULT');
                $currencies = $this->getCurrency(intval($id_currency));
                $currency = 'PLN';
                foreach ($currencies as $c) {
                    if ($c['id_currency']==$id_currency) {
                        $currency = $c['iso_code'];
                    }
                }
                if ($amount>=300 && $currency=='PLN') {
                    $amountGrosh = $amount*100;

					$result = self::requestGet("https://secure.przelewy24.pl/kalkulator_raty.php?ammount=".$amountGrosh);
                    $result_tab = explode('<br>', $result);

                    $smarty->assign(array(
                        'part_count'=>$result_tab[0],
                        'part_cost'=>$result_tab[1],
                        'product_ammount'=>$amount,
						'p24_ajax_url' => $this->context->link->getModuleLink('przelewy24', 'paymentAjax', array(), Configuration::get('PS_SSL_ENABLED') == 1),
                    ));

                    return $this->display(__FILE__, 'installmentRightColumnProduct.tpl');
                }
            }
        }
    }

    public function hookDisplayOrderDetail($params) {
        global $smarty;
        $order = new Order($_GET['id_order']);
		$state = new OrderState($order->current_state);

        if ($order->module=='przelewy24'&&!($state->paid || $order->current_state == Configuration::get('P24_ORDER_STATE_2'))) {
            $smarty->assign('p24_retryPaymentUrl', $this->context->link->getModuleLink('przelewy24', 'paymentConfirmation', array('order_id'=>$order->id)));
            return $this->display(__FILE__, 'renewPaymentOrderDetail.tpl');
        }
    }

	public function hookDisplayCustomerAccount()
	{
		if (Configuration::get('P24_ONECLICK_ENABLED')==1) {
			return $this->display(__FILE__, 'myStoredCards.tpl');
		}
	}
	
	public function hookDisplayHeader($params) {
        global $smarty;
        $this->removeDiscount();
		if ($this->removeExtrachargeProductFromCart()) {
			return $this->display(__FILE__, 'refreshAjaxCart.tpl');
		}
	}

	public function hookDisplayInvoice($params) {
        global $smarty;
        if (Configuration::get('P24_IVR_ENABLED')==1) {
			$id_order = (int)$params['id_order'];
			$order = new Order($id_order);
			$state = new OrderState($order->current_state);
			$address = new Address((int)$order->id_address_delivery);
			$clientPhone = (!empty($address->phone_mobile) ? $address->phone_mobile : $address->phone);

			if (!$state->paid) return <<<HTML
			<script>
				$(document).ready(function(){
					$('ul#toolbar-nav').append('<li><a id="page-header-p24-ivr" class="toolbar_btn" href="#" title="IVR"><i class="process-icon-phone icon-phone"></i><div>{$this->l('Pay with IVR')}</div></a></li>');
					$('#page-header-p24-ivr').click(function(){
						if (confirm("{$this->l('Do you want to start payment by IVR and make call back to the customer?')} {$clientPhone}")) {
							$.ajax('{$this->context->link->getModuleLink('przelewy24', 'paymentAjax', array(), Configuration::get('PS_SSL_ENABLED') == 1)}', {
								method: 'POST', type: 'POST',
								data : { action: 'runIVR', id_order: '{$id_order}' },
								success : function(data) {
									window.location.reload();
								},
							});
						}
					});
				});
			</script>
HTML;
		}
	}
	
	public function hookDisplayBackOfficeTop($params) {
        global $smarty;
		$url = 'http://www.przelewy24.pl/pobierz';
        
		if (Tools::getValue('p24_update_plugin') == true) {
			$success = false;
			$html = self::requestGet($url);
			if (preg_match('#<a href="([^"]+/przelewy24_presta15_16_[^/"]+.zip)"#im', $html, $matches) == 1) {

				$url = "http://przelewy24.pl".$matches[1];
				$file = tempnam(sys_get_temp_dir(), 'p24_update_');
				
				file_put_contents($file, self::requestGet($url));

				if (filesize($file) > 0) {
					if (Tools::ZipExtract($file, _PS_MODULE_DIR_)) {
						parent::uninstall();
					}
				}

				@unlink($file);
				if (isset($_COOKIE["p24_plugin_update"])) unset($_COOKIE["p24_plugin_update"]);
				if (_PS_VERSION_<1.6) {
					$link = new Link(); 
					Tools::redirectAdmin($link->getAdminLink('AdminModules').'&anchor=anchorPrzelewy24');
				}
			}
			return;
		}
		
        try { // update plugin mechanism
			$p24_plugin_update = '';
			if (isset($_COOKIE['p24_plugin_update'])) $p24_plugin_update = $_COOKIE['p24_plugin_update'];
			if (empty($p24_plugin_update)) {
				$html = self::requestGet($url);
				if (preg_match('#<a href="[^"]+/przelewy24_presta15_16_([^/"]+).zip"#im', $html, $matches) == 1) {
					setcookie('p24_plugin_update', $matches[1], time() + 172800); // co dwa dni
					$p24_plugin_update = $matches[1];
				}
			}
			if ($p24_plugin_update > $this->version) {
				$link = new Link();
				$p24_update_link = $link->getAdminLink('AdminModules').'&module_name=przelewy24&p24_update_plugin=true';
				$message = "<div class=\"alert alert-info\">Dostępna jest nowsza wersja wtyczki Przelewy24 {$p24_plugin_update}. <a href=\"{$p24_update_link}\">Zaktualizuj teraz</a></div>";

				$smarty->assign(array(
					'p24_message'      => $message,
					'p24_message_id'   => uniqid('p24_'),
				));
				return $this->display(__FILE__, 'updatePlugin.tpl');
			}
		
		} catch (Exception $e) {
			error_log($e->getMessage());
		}

	}
	
	
    public static function getHttpProtocol() {
        if (isset($_SERVER['HTTPS'])&&$_SERVER['HTTPS']!='off') {
            return 'https://';
        } else {
            return 'http://';
        }
    }

	private function removeExtrachargeProductFromCart() {
		if ($extracharge_product = Configuration::get('P24_EXTRACHARGE_PRODUCT')) {
			if ($cart = Context::getContext()->cart) { 
				if ($cart->containsProduct($extracharge_product)) {
					$cart->updateQty(0,$extracharge_product);
				}
			}
		}
		return false;
	}
	/*
	 * Zwraca kwotę dodatkowej opłaty przy wyborze przelewy24
	 * @param int
	 * @return float
	 * 
	 * */
    public function getExtrachargeAmount($id_cart) {
		$extracharge_amount = 0;
		$cart = new Cart((int)$id_cart);;

		$amount = $cart->getOrderTotal(true, Cart::BOTH);
		$amount = $this->getP24Amount(intval($cart->id_currency), $amount);
		
		if (Configuration::get('P24_EXTRACHARGE_ENABLED')==1 && $amount > 0 && (int)Configuration::get('P24_EXTRACHARGE_PRODUCT') > 0) {

			$inc_amount_settings = (float)Configuration::get('P24_EXTRACHARGE_AMOUNT');
			$inc_percent_settings = (float)Configuration::get('P24_EXTRACHARGE_PERCENT');

			$inc_amount  = round($inc_amount_settings > 0 ? $inc_amount_settings * 100 : 0);
			$inc_percent = round($inc_percent_settings > 0 ? $inc_percent_settings / 100 * $amount : 0);

			$extracharge_amount = max($inc_amount, $inc_percent);

		}
		return $extracharge_amount;
	}

	public function cartHasDiscount($cart = null) {
		if (empty($cart)) {
			$cart = Context::getContext()->cart;
		}
		if ($cart) {
			foreach ($cart->getCartRules() as $item) {
				if (substr($item['code'],0,4) == $this->discount_code_prefix) {
					return $item['id_cart_rule'];
				}
			}
		}
		return false;
	}

	public function removeDiscount($cart = null) {
		if (Configuration::get('P24_EXTRADISCOUNT_ENABLED') > 0 && strpos($_SERVER['REQUEST_URI'], $this->name) === false) {
			if (empty($cart)) {
				$cart = Context::getContext()->cart;
			}
			$discountId = $this->cartHasDiscount($cart);
			if ($discountId) {
				$cart->removeCartRule($discountId);

				$cart_rule = new CartRule($discountId);
				if (Validate::isLoadedObject($cart_rule))
					$cart_rule->delete();
			}
		}
	}

	/*
	 * Dodaje do koszyka kupon zniżkowy, przy wyborze przelewy24
	 * @param cart
	 * @return void
	 * 
	 * */
	public function addDiscount($cart = null) {
		if (Configuration::get('P24_EXTRADISCOUNT_ENABLED') > 0) {
			if (empty($cart)) {
				$cart = Context::getContext()->cart;
			}
			if ($cart) {
				$discountId = $this->cartHasDiscount($cart);
				if ($discountId == false) {
					$cart_rule = new CartRule();

					$languages = Language::getLanguages();
					foreach($languages as $key => $language){
						$array[$language['id_lang']] = "Rabat za użycie Przelewy24";
					}

					$cart_rule->name = $array;
					$cart_rule->code = strtoupper(uniqid($this->discount_code_prefix));
					$cart_rule->description = "Rabat za użycie Przelewy24";
					$cart_rule->partial_use = 1;
					$cart_rule->reduction_currency = intval(Configuration::get('PS_CURRENCY_DEFAULT'));
					$cart_rule->active = 1;
					$cart_rule->id_customer = $cart->id_customer;
					$cart_rule->date_from = date('Y-m-d 00:00:00');
					$cart_rule->date_to = date('Y-m-d h:i:s', mktime(0, 0, 0, date("m"), date("d")+1, date("Y")));
					$cart_rule->minimum_amount = '1';
					$cart_rule->minimum_amount_currency = '1';
					$cart_rule->quantity = '1';
					$cart_rule->quantity_per_user = '1';
					$cart_rule->product_restriction = '1';
					$cart_rule->priority = '1';
					$cart_rule->reduction_product = '';
					$cart_rule->date_add = 'NOW()';
					$cart_rule->date_upd = 'NOW()';

					$cart_rule->reduction_amount  = Configuration::get('P24_EXTRADISCOUNT_ENABLED') == 1 ? Configuration::get('P24_EXTRADISCOUNT_AMOUNT')  : 0;
					$cart_rule->reduction_percent = Configuration::get('P24_EXTRADISCOUNT_ENABLED') == 2 ? Configuration::get('P24_EXTRADISCOUNT_PERCENT') : 0;
					
					$cart_rule->add();

					$cart->addCartRule($cart_rule->id);
				}
			}
		}

	}
	public static function soap_method_exists($soapClient, $method) {
		$list = $soapClient->__getFunctions();
		if (is_array($list)) {
			foreach ($list as $line) {
				list($type,$name) = explode(' ',$line,2);
				if (strpos($name,$method) === 0) return true;
			}
		}
		return false;
	}
	private function checkIvrPresent() {
		$P24C = new Przelewy24Class(Configuration::get('P24_MERCHANT_ID'), Configuration::get('P24_SHOP_ID'), Configuration::get('P24_SALT'), Configuration::get('P24_TEST_MODE'));
		$has_ivr = false;
		try {
			$s=new SoapClient($P24C->getHost().$this->getWsdlService(Configuration::get('P24_MERCHANT_ID')), array('trace'=>true, 'exceptions'=>true));
			$has_ivr = $this->soap_method_exists($s, 'TransactionMotoCallBackRegister');
		} catch (Exception $e) {
			error_log(__METHOD__.' '.$e->getMessage());
		}

		return !!$has_ivr;
	}
	
	private function ccCheckRecurrency() {
		$P24C = new Przelewy24Class(Configuration::get('P24_MERCHANT_ID'), Configuration::get('P24_SHOP_ID'), Configuration::get('P24_SALT'), Configuration::get('P24_TEST_MODE'));
		try {
			$s=new SoapClient($P24C->getHost().$this->getWsdlCCService(), array('trace'=>true, 'exceptions'=>true));
			$res=$s->checkRecurrency(Configuration::get('P24_SHOP_ID'), Configuration::get('P24_SALT'));
		} catch (Exception $e) {
			error_log(__METHOD__.' '.$e->getMessage());
		}
		return !!$res;
	}
	private function apiTestAccess() {
		$P24C = new Przelewy24Class(Configuration::get('P24_MERCHANT_ID'), Configuration::get('P24_SHOP_ID'), Configuration::get('P24_SALT'), Configuration::get('P24_TEST_MODE'));
		try {
			$s=new SoapClient($P24C->getHost().$this->getWsdlService(Configuration::get('P24_MERCHANT_ID')), array('trace'=>true, 'exceptions'=>true));
			$res=$s->TestAccess(Configuration::get('P24_SHOP_ID'), Configuration::get('P24_API_KEY'));
		} catch (Exception $e) {
			error_log(__METHOD__.' '.$e->getMessage());
		}

		return !!$res;
	}
	public function availablePaymentMethods($only24at7 = true, $currency = 'PLN') {
		$P24C = new Przelewy24Class(Configuration::get('P24_MERCHANT_ID'), Configuration::get('P24_SHOP_ID'), Configuration::get('P24_SALT'), Configuration::get('P24_TEST_MODE'));

		try {
			$s=new SoapClient($P24C->getHost().$this->getWsdlService(Configuration::get('P24_MERCHANT_ID')), array('trace'=>true, 'exceptions'=>true));
			$res=$s->PaymentMethods(Configuration::get('P24_SHOP_ID'), Configuration::get('P24_API_KEY'), Context::getContext()->language->iso_code);
		} catch (Exception $e) {
		    error_log(__METHOD__.' '.$e->getMessage());
		}
		if ($res->error->errorCode === 0) {

			if ($only24at7) {
				foreach ($res->result as $key => $item) {
					if (!$item->status) {
						unset($res->result[$key]);
					}
				}
			}
			if ($currency != 'PLN') {
				foreach ($res->result as $key => $item) {
					if (!in_array($item->id, $this->getChannelsNonPln())) {
						unset($res->result[$key]);
					}
				}
			}
			return $res->result;
		}
		return false;
	}
	public function validateGA($nr) {
		if (preg_match('#^[A-Z]{2}\-\d+\-\d+$#', $nr)) return $nr;
		return false;
	}
	public static function getChannelsNonPln() {
		return array(124,140,145,152,66,92);
	}
	public static function getChannelsRaty() {
		return array(72,129,136);
	}
    public static function getWsdlService($merchantId) {
		return str_replace('[P24_MERCHANT_ID]',$merchantId,'external/[P24_MERCHANT_ID].wsdl');
	}
    public static function getWsdlCCService() {
		return 'external/wsdl/charge_card_service.php?wsdl';
	}
}
